//
//  REnvironment.m
//  R
//
//  Created by Byron Ellis on 1/20/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "REnvironment.h"
#import "RInterpreter.h"
#include <Rinternals.h>

@implementation REnvironment

//Only really need a single R_GlobalEnv object so save some memory
+ (REnvironment*)global {
	REnvironment *globalEnv = nil;
	if(nil == globalEnv) 
		globalEnv = [[REnvironment alloc] initWithPointer:R_GlobalEnv];
	return globalEnv;
}

- (RValue*)evaluate:(RValue*)anExpr blocking:(BOOL)block {
	NSLock *gil = [REnvironment gil];
	BOOL    cont = NO;
	RValue *result = nil;
	if(YES == block) {
		[gil lock];
		cont = YES;
	} else
		cont = [gil tryLock];
	if(YES == cont) {
		SEXP res,expr;
		expr = (SEXP)[anExpr pointer];
		RInterpreter *si = [RInterpreter sharedInterpreter];
		BOOL suppress = [si suppressOutput];
		[si setSuppressOutput:YES];
		if(TYPEOF(expr)==EXPRSXP) expr = VECTOR_ELT(expr,0);
		NSInteger error = 0;
		res = R_tryEval(expr,(SEXP)[self pointer],&error);
		result = error == 0 ? [RValue valueWithPointer:res] : nil;
		[si setSuppressOutput:suppress];		
		[gil unlock];
	} else
		NSLog(@"Failed to get execution lock");
	return result;
}

- (RValue*)symbolForName:(NSString*)name {
	SEXP find = findVar(install([name UTF8String]),(SEXP)rPtr);
	return find == R_UnboundValue ? nil : [RValue valueWithPointer:find];
}

@end
