#import <Cocoa/Cocoa.h>
#import "RApplication.h"
#import "RInterpreter.h"

int main(int argc, char *argv[])
{
	//We do a custom main() so that we can do most of the initialization
	//via R.
	NSDictionary *info = [[NSBundle mainBundle] infoDictionary];
	
	//Initialize NSApp
	Class         Main = NSClassFromString([info objectForKey:@"NSPrincipalClass"]);
	if(nil == Main) {
		NSLog(@"Unable to locate principal class: %@",[info objectForKey:@"NSPrincipalClass"]);
		return 1;
	}
	[Main sharedApplication];
	//Load the main Nib
	[NSBundle loadNibNamed:[info objectForKey:@"NSMainNibFile"] owner:NSApp];
	//Run until we're done initializing (the delegate should break the event loop).
	//At this point, the interpreter should be initialized with a delegate if needed.
	[NSApp run];
	//Next we run the RInterpreter itself.
	[[RInterpreter sharedInterpreter] run];
	//We shouldn't ever get here...
	return 0;
}
